/*************************************************************************/
/*          @    QD̃CN[h                         */
/*************************************************************************/
#include "dd_lib.h" 

D3DMATRIX  viewMatrix;          //_}gNX
D3DMATRIX  projMatrix;          //ϊp}gNX
D3DMATRIX  world,world2,world3; //[hϊp}gNX 

D3DLVERTEX v[6];                //_f[^

//L[͗pϐ
struct {
		int Up; 
		int	Down; 
		int Left;
		int Right;
} KeyData;

//_
struct {
	float x;
	float y;
	float z;
	float Angle;
} View;

//֐vg^Cv
void InitProc(void);
void AngleChange(void);
void IM_Proc(void);

//////////////////////////////////////////////////////////////////////////////
//}gNXTCYݒ}N
#define MAT_SIZE  1000.0f

//}bvf[^i[z
int X_Max = 19, Y_Max = 19;
static int MapData[20][20] =  {
				{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
				{ 0, 8, 2, 2, 2, 2, 7, 7, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
				{ 0, 4, 1, 1, 1, 3, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
				{ 0, 4, 5, 5, 5, 3, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
				{ 0, 6, 0, 0, 0, 6, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
				{ 0, 6, 0, 0, 0, 6, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
				{ 0, 4, 2, 2, 2, 5, 7, 7, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
				{ 0, 4, 1, 1, 3, 0, 0, 0, 6, 0,12, 0, 0, 0, 0, 0, 0, 0, 0, 0},
				{ 0, 4, 5, 5, 5, 7, 7, 7,11, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0},
				{ 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0},
				{ 0, 6, 0, 0, 0, 8, 7, 7, 7, 7, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0},
				{ 0, 6, 0, 0, 0, 6, 0, 0, 0, 0,13, 0, 0, 0, 0, 0, 0, 0,12, 0},
				{ 0, 6, 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6, 0},
				{ 0,10, 7, 7, 7, 1, 7, 7, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6, 0},
				{ 0, 0, 0, 0, 0, 6, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6, 0},
				{ 0, 0, 0, 0, 0, 6, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6, 0},
				{ 0, 0, 0, 0, 0, 6, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6, 0},
				{ 0, 0, 0, 0, 0, 6, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6, 0},
				{ 0, 0, 0, 0, 0,10, 7, 7, 5, 7, 7, 7, 7, 7, 7, 7, 7, 7,11, 0},
				{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}
			};

/*************************************************************************/
/*          @            @@C[v @                            */
/*************************************************************************/
void Main_Proc(HWND hwnd)
{
	//
	InitProc();
		
	//_ύX
	AngleChange();

	//hl
	IM_Proc();
	
	char buffer[256];
	sprintf(buffer, "x = %f Y = %f z = %f Angle = %f", View.x, View.y, View.z, View.Angle);
	DD_FontShow(buffer,   15,    100,    50,    0,   0, 255);
}

/************************************************************************/
/*                @@@@  ֐  @@@@@                  */
/************************************************************************/
void InitProc(void)
{
	static bool LoadFlg = false; 
	if (LoadFlg == false) {
		LoadFlg = true;
		
		//ϊ}gbNX̏@@@@@NbsO
		CreateProjectionMatrix(projMatrix, 100, 6000, (float)(atan(1.0)*2));
		
		//_񏉊
		View.x     = 1600;
		View.y     = 350;
		View.z     = -1200; 
		View.Angle = 270.0f;

		//eNX`
		pTexture = new D3DTexture;
		pTexture->Load(DDObject, pD3DDevice, "d3dtest.bmp");
		hTexture = pTexture->GetHandle();

		//}eA쐬									
		D3DMATERIAL mat;
		pD3D->CreateMaterial(&pD3DMat,NULL);
		ZeroMemory(&mat,sizeof(mat));
		mat.dwSize = sizeof(mat);
		mat.diffuse.r  = 1.0;  mat.diffuse.g  = 1.0;  mat.diffuse.b  = 1.0;
		mat.ambient.r  = 0.50; mat.ambient.g  = 0.50; mat.ambient.b  = 0.50;
		mat.specular.r = 0;    mat.specular.g = 0;	  mat.specular.b = 0;
		mat.emissive.r = 0.0;  mat.emissive.g = 0.0;  mat.emissive.b = 0.0;
		mat.power = 0.0;
		mat.dwRampSize = 1;
		//mat.hTexture = hTexture;
		pD3DMat->SetMaterial(&mat);
		pD3DMat->GetHandle(pD3DDevice,&hMaterial);

		//Cg
		D3DLIGHT2 lt;
		pD3D->CreateLight(&pD3DLight,NULL);
		ZeroMemory(&lt,sizeof(lt));
		lt.dwSize = sizeof(lt);
	    lt.dltType = D3DLIGHT_DIRECTIONAL;
	    lt.dvPosition.x = -100.0f;   lt.dvPosition.y = 100.0f;    lt.dvPosition.z = -100.0f;
		lt.dvDirection.x = -100.0;   lt.dvDirection.y = -1000.0;  lt.dvDirection.z = -100.0;
	    lt.dcvColor.r = D3DVAL(1.0); lt.dcvColor.g = D3DVAL(1.0); lt.dcvColor.b = D3DVAL(1.0);
		lt.dwFlags = D3DLIGHT_ACTIVE;

		pD3DLight->SetLight((D3DLIGHT*)&lt);
		pD3DVP->AddLight(pD3DLight);
	}
}

/************************************************************************/
/*                @@@@  _ύX֐  @@@@                  */
/************************************************************************/
void AngleChange(void)
{
	//_ύX
	Key_Input(VK_UP,   &KeyData.Up);    // 
	Key_Input(VK_DOWN, &KeyData.Down);  // 
	Key_Input(VK_LEFT, &KeyData.Left);  // 
	Key_Input(VK_RIGHT,&KeyData.Right); // E

	static float SaveX, SaveZ;

	//_ύX
	if (KeyData.Right== HOLD_KEY)  {
		View.Angle -= FrameTime * 60.0f;
		if (View.Angle <= -360.0) View.Angle += 360;
	}
	if (KeyData.Left == HOLD_KEY)  {
		View.Angle += FrameTime * 60.0f;
		if (View.Angle >= 360.0) View.Angle -= 360;
	}
	
	//_ړ
	if (KeyData.Up  == HOLD_KEY)  {
		SaveZ = View.z + FrameTime * 1600.0f * sin(View.Angle * rad);
		SaveX = View.x + FrameTime * 1600.0f * cos(View.Angle * rad);
		if ((MapData[-(int)((SaveZ - 200) / MAT_SIZE)]
						[(int)((SaveX + 200) / MAT_SIZE)] != 0) && 
		    (MapData[-(int)((SaveZ + 200) / MAT_SIZE)]
						[(int)((SaveX - 200) / MAT_SIZE)] != 0) &&
		    (MapData[-(int)((SaveZ - 200) / MAT_SIZE)]
						[(int)((SaveX - 200) / MAT_SIZE)] != 0) &&
		    (MapData[-(int)((SaveZ + 200) / MAT_SIZE)]
						[(int)((SaveX + 200) / MAT_SIZE)] != 0)) {
			View.z = SaveZ;
			View.x = SaveX;
		}
	}
	if (KeyData.Down == HOLD_KEY)  {
		SaveZ = View.z - FrameTime * 1600.0f * sin(View.Angle * rad);
		SaveX = View.x - FrameTime * 1600.0f * cos(View.Angle * rad);
		if ((MapData[-(int)((SaveZ - 200) / MAT_SIZE)]
						[(int)((SaveX + 200) / MAT_SIZE)] != 0) && 
		    (MapData[-(int)((SaveZ + 200) / MAT_SIZE)]
						[(int)((SaveX - 200) / MAT_SIZE)] != 0) &&
		    (MapData[-(int)((SaveZ - 200) / MAT_SIZE)]
						[(int)((SaveX - 200) / MAT_SIZE)] != 0) &&
		    (MapData[-(int)((SaveZ + 200) / MAT_SIZE)]
						[(int)((SaveX + 200) / MAT_SIZE)] != 0)) { 
			View.z = SaveZ;
			View.x = SaveX;
		}
	}
	
	//r[}gNX@ir[}gNXA@_ʒuA@Î_j
	CreateViewMatrix(viewMatrix, D3DVECTOR(View.x, View.y, View.z), 
		D3DVECTOR(View.x + cos(View.Angle * rad) * 100, View.y, View.z + sin(View.Angle * rad) * 100));
}

/************************************************************************/
/*                @ @@_Wn֐@ @@@                  */
/************************************************************************/
void CreateWall1(int i, int j)
{
	LVertexSet(v[0],        0, 800, -MAT_SIZE, RGB_MAKE(255,255,255), 1, 0); 
	LVertexSet(v[1], MAT_SIZE, 800, -MAT_SIZE, RGB_MAKE(255,255,255), 0.5, 0);
	LVertexSet(v[2],        0,   0, -MAT_SIZE, RGB_MAKE(255,255,255), 1, 0.5);
	v[3] = v[2];
	v[4] = v[1];
	LVertexSet(v[5], MAT_SIZE,   0, -MAT_SIZE, RGB_MAKE(255,255,255), 0.5, 0.5);
	
	CreateTranslateMatrix(world, j * MAT_SIZE, 0, i * -MAT_SIZE);
	pD3DDevice->SetTransform(D3DTRANSFORMSTATE_WORLD, &world);
	pD3DDevice->DrawPrimitive(D3DPT_TRIANGLELIST, D3DVT_LVERTEX, (LPVOID)v, 6, D3DDP_WAIT);
}

void CreateWall2(int i, int j)
{
	LVertexSet(v[0], MAT_SIZE, 800, -MAT_SIZE, RGB_MAKE(255,255,255), 1, 0); 
	LVertexSet(v[1], MAT_SIZE, 800,         0, RGB_MAKE(255,255,255), 0.5, 0);
	LVertexSet(v[2], MAT_SIZE,   0, -MAT_SIZE, RGB_MAKE(255,255,255), 1, 0.5);
	v[3] = v[2];
	v[4] = v[1];
	LVertexSet(v[5], MAT_SIZE,   0,         0, RGB_MAKE(255,255,255), 0.5, 0.5);

	CreateTranslateMatrix(world, j * MAT_SIZE, 0, i * -MAT_SIZE);
	pD3DDevice->SetTransform(D3DTRANSFORMSTATE_WORLD, &world);
	pD3DDevice->DrawPrimitive(D3DPT_TRIANGLELIST, D3DVT_LVERTEX, (LPVOID)v, 6, D3DDP_WAIT);
}

void CreateWall3(int i, int j)
{
	LVertexSet(v[0], MAT_SIZE, 800, 0, RGB_MAKE(255,255,255), 1, 0); 
	LVertexSet(v[1],        0, 800, 0, RGB_MAKE(255,255,255), 0.5, 0);
	LVertexSet(v[2], MAT_SIZE,   0, 0, RGB_MAKE(255,255,255), 1, 0.5);
	v[3] = v[2];
	v[4] = v[1];
	LVertexSet(v[5],        0,   0, 0, RGB_MAKE(255,255,255), 0.5, 0.5);

	CreateTranslateMatrix(world, j * MAT_SIZE, 0, i * -MAT_SIZE);
	pD3DDevice->SetTransform(D3DTRANSFORMSTATE_WORLD, &world);
	pD3DDevice->DrawPrimitive(D3DPT_TRIANGLELIST, D3DVT_LVERTEX, (LPVOID)v, 6, D3DDP_WAIT);
}

void CreateWall4(int i, int j)
{
	LVertexSet(v[0], 0, 800,         0, RGB_MAKE(255,255,255), 1, 0); 
	LVertexSet(v[1], 0, 800, -MAT_SIZE, RGB_MAKE(255,255,255), 0.5, 0);
	LVertexSet(v[2], 0,   0,         0, RGB_MAKE(255,255,255), 1, 0.5);
	v[3] = v[2];
	v[4] = v[1];
	LVertexSet(v[5], 0,   0, -MAT_SIZE, RGB_MAKE(255,255,255), 0.5, 0.5);

	CreateTranslateMatrix(world, j * MAT_SIZE, 0, i * -MAT_SIZE);
	pD3DDevice->SetTransform(D3DTRANSFORMSTATE_WORLD, &world);
	pD3DDevice->DrawPrimitive(D3DPT_TRIANGLELIST, D3DVT_LVERTEX, (LPVOID)v, 6, D3DDP_WAIT);
}

void WallSet(int i, int j)
{
	switch (MapData[i][j]) {
		case 1://ǖ
			break;
		case 2://
			CreateWall3(i, j); break;
		case 3://E
			CreateWall2(i, j); break;
		case 4://
			CreateWall4(i, j); break;
		case 5://
			CreateWall1(i, j); break;
		case 6://ʘHikj
			CreateWall2(i, j); CreateWall4(i, j); break;
		case 7://ʘHij
			CreateWall1(i, j); CreateWall3(i, j); break;
		case 8://pij
			CreateWall3(i, j); CreateWall4(i, j); break;
		case 9://piEj
			CreateWall3(i, j); CreateWall2(i, j); break;
		case 10://pij
			CreateWall1(i, j); CreateWall4(i, j); break;
		case 11://piEj
			CreateWall1(i, j); CreateWall2(i, j); break;
		case 12://s~܂ij
			CreateWall3(i, j); CreateWall2(i, j); CreateWall4(i, j); break;
		case 13://s~܂ij
			CreateWall2(i, j); CreateWall1(i, j); CreateWall4(i, j); break;
		case 14://s~܂iEj
			CreateWall1(i, j); CreateWall2(i, j); CreateWall3(i, j); break;
		case 15://s~܂ij
			CreateWall1(i, j); CreateWall3(i, j); CreateWall4(i, j); break;
	}	

	//Vƕǂ̐
	LVertexSet(v[0], MAT_SIZE, 0,        0, RGB_MAKE(255,255,255), 0.49, 0); 
	LVertexSet(v[1],        0, 0,        0, RGB_MAKE(255,255,255), 0, 0);
	LVertexSet(v[2], MAT_SIZE, 0,-MAT_SIZE, RGB_MAKE(255,255,255), 0.49, 0.49);
	v[3] = v[2];
	v[4] = v[1];
	LVertexSet(v[5],        0, 0,-MAT_SIZE, RGB_MAKE(255,255,255), 0, 0.49);

	CreateTranslateMatrix(world, j * MAT_SIZE, 0, i * -MAT_SIZE);
	pD3DDevice->SetTransform(D3DTRANSFORMSTATE_WORLD, &world);
	pD3DDevice->DrawPrimitive(D3DPT_TRIANGLELIST, D3DVT_LVERTEX, (LPVOID)v, 6, D3DDP_WAIT);

	CreateTranslateMatrix(world, j * MAT_SIZE, 800, i * -MAT_SIZE);
	pD3DDevice->SetTransform(D3DTRANSFORMSTATE_WORLD, &world);
	pD3DDevice->DrawPrimitive(D3DPT_TRIANGLELIST, D3DVT_LVERTEX, (LPVOID)v, 6, D3DDP_WAIT);
}

/************************************************************************/
/*                @@@@ @@hl֐@ @@@@                  */
/************************************************************************/
void IM_Proc(void) 
{
	D3DRECT rect;

	//_OXe[g̐ݒ
	pD3DDevice->SetRenderState(D3DRENDERSTATE_ZENABLE, TRUE);//yobt@Lɂ
	rect.x1 = 0; rect.x2 = 640;
	rect.y1 = 0; rect.y2 = 480;
	pD3DVP->Clear(1,&rect,D3DCLEAR_ZBUFFER);
	pD3DDevice->SetRenderState(D3DRENDERSTATE_CULLMODE, D3DCULL_NONE);
	pD3DDevice->SetRenderState(D3DRENDERSTATE_SHADEMODE, D3DSHADE_GOURAUD);

	//CgZbg
	pD3DDevice->SetLightState(D3DLIGHTSTATE_MATERIAL,hMaterial);
	pD3DDevice->SetLightState(D3DLIGHTSTATE_AMBIENT,RGB_MAKE(128,128,128));

	
	//tHO
	float    fog_start = 101.0f;
	float    fog_end   = 3000.0f;
	D3DCOLOR fog_color = D3DRGB(0, 0, 0);

	pD3DDevice->SetRenderState(D3DRENDERSTATE_FOGENABLE, TRUE);
	pD3DDevice->SetRenderState(D3DRENDERSTATE_FOGCOLOR, fog_color);

	pD3DDevice->SetLightState(D3DLIGHTSTATE_FOGMODE, D3DFOG_LINEAR);
	pD3DDevice->SetLightState(D3DLIGHTSTATE_FOGSTART, *((DWORD*)&fog_start));
	pD3DDevice->SetLightState(D3DLIGHTSTATE_FOGEND, *((DWORD*)&fog_end));
	
	///////////////////////////////// `Jn //////////////////////////////////
	pD3DDevice->BeginScene();

	//eNX`Zbg
	pD3DDevice->SetRenderState(D3DRENDERSTATE_TEXTUREHANDLE,hTexture);

	//_ݒAϊݒ
	pD3DDevice->SetTransform(D3DTRANSFORMSTATE_VIEW, &viewMatrix);
	pD3DDevice->SetTransform(D3DTRANSFORMSTATE_PROJECTION, &projMatrix);

	/////////////////////////////////////////////////////////////////////////////
	static float Angle = 0.0f;
	Angle += FrameTime * 250.0f;
	if(Angle >= 360) Angle -= 360.0f;

	LVertexSet(v[0], 200, 200, 0, RGB_MAKE(255,255,255), 1, 0); 
	LVertexSet(v[1],-200, 200, 0, RGB_MAKE(255,255,255), 0, 0);
	LVertexSet(v[2], 200,-200, 0, RGB_MAKE(255,255,255), 1, 1);
	v[3] = v[2];
	v[4] = v[1];
	LVertexSet(v[5],-200,-200, 0, RGB_MAKE(255,255,255), 0, 1);

	//ϊ}gNX쐬
	CreateRotateYMatrix  (world, Angle * rad); //x]
	CreateTranslateMatrix(world2, 0, 0, 3000); //sړ
	CreateRotateXMatrix  (world3, 0 * rad);    //w]

	MulMatrix(world, world2, world); //x] ~ sړ
	MulMatrix(world, world3, world); //Zs ~ w]  
	
	//xNgɕϊ}gNXZbg
	pD3DDevice->SetTransform(D3DTRANSFORMSTATE_WORLD, &world);
	//DrawPrimitiveɂ`
	pD3DDevice->DrawPrimitive(D3DPT_TRIANGLELIST, D3DVT_LVERTEX, (LPVOID)v, 6, D3DDP_WAIT);

	/////////////////////////////////////////////////////////////////////////////
	//}bv`揈
	int i,j;
	for (i = 0; i <= Y_Max; i ++) {
		for (j = 0; j <= X_Max; j ++) {
			if (MapData[i][j] != 0) WallSet(i, j);
		}
	}
	
	pD3DDevice->EndScene();
}

/************************************************************************/
/*                @@@@ Cxg֐ @@@@@                  */
/************************************************************************/
void Event_Proc(WPARAM wParam,HWND hwnd)
{
	switch (wParam) {
		//drbꂽ̃Cxg
		case VK_ESCAPE:
			//vOI
			PostMessage(hwnd, WM_CLOSE, 0, 0);
			break;
	}	
}