#define STRICT
#define D3D_OVERLOADS

#include <windows.h>    //Windows̕Wwb_[t@C
#include <stdio.h>      //Whnwb_t@C
#include <string.h>     //񏈗pwb_t@C
#include <math.h>       //w֐wb_t@C

#include "dsound.h"		//DirectSoundwb_[t@C
#include "ddraw.h"      //DirectDrawwb_[t@C 
#include "d3d.h"

/*********************************************************************************************/
/*                      @@@          }N錾          @@                             */
/*********************************************************************************************/
#define   BITMAP_NUM    100
#define   SOUND_NUM     100
#define   SCREEN_WIDTH  640
#define   SCREEN_HEIGHT 480

#define RELEASE(x) 	if(x){x->Release();x=NULL;}

/*********************************************************************************************/
/*                                  O[oϐ̐錾                                     */
/*********************************************************************************************/
// EBhEnh
HWND hwnd;    

// DirectDrawIuWFNg
LPDIRECTDRAW2            DDObject          = NULL;   //_CNgh[IuWFNg
LPDIRECTDRAWSURFACE3     DDFront           = NULL;   //_CNgh[T[tFXi\ʁj
LPDIRECTDRAWSURFACE3     DDBack            = NULL;   //_CNgh[T[tFXiʁj
LPDIRECTDRAWSURFACE3     pZBuffer          = NULL;   //yobt@

typedef struct {
	LPDIRECTDRAWSURFACE3 Surface;                    //rbg}bvێpT[tFX
	char                 *SaveData;                  //T[tFXXg΍f[^

	DWORD	             dwWidth;                    //T[tFXTCY
	DWORD	             dwHeight;
	DWORD	             dwPitch;
} SurfaceData;
SurfaceData              Bitmap[BITMAP_NUM];	

// DirectSoundIuWFNg
LPDIRECTSOUND            DSObject          = NULL;   //_CNgTEhIuWFNg         
LPDIRECTSOUNDBUFFER      Wave[SOUND_NUM];            //_CNgTEhobt@          

//ԏpϐ
static float             FrameTime = 0.0;   //ɂԂi[
static long int          Save_time;         //ɂԂZo邽߂̃WX^                    

// L[Ԓ萔
static const int         FREE_KEY = 0;      // L[ĂȂ
static const int         PUSH_KEY = 1;      // L[u
static const int         PULL_KEY = 2;      // L[ꂽu
static const int         HOLD_KEY = 3;      // L[Ă

//WAϊpϐ
static float rad = (float)(3.14 / 180);

//CX^Xnh
static HINSTANCE _Instance;

//lhchĐpϐ
static char              MciBuffer[32];
bool PlayFlg = false;

//}EXWۑpϐ
int MouseX, MouseY;

/*********************************************************************************************/
/*                                   vg^Cv錾         @                             */
/*********************************************************************************************/
//EChE֐
long FAR PASCAL WindowProc(HWND,UINT,WPARAM,LPARAM);    //C֐

//_CNgh[n֐
bool DD_INIT(HWND);                                     //_CNgh[֐
void DD_END(HWND);                                      //_CNgh[I֐
void DD_DrawBitmap(int, int, SurfaceData&,              //rbg}bv`֐
				 int, int, int, int);                
void DD_DrawLine(int ,int ,int ,int ,                   //C`揈
				 int , int, int, int);    
void DD_FontShow(char *, int, int, int, int,            //`֐ 
				 int, int ,bool); 
void DD_BackInit(void);                                 //XN[̏֐
bool DD_LoadBitmap(SurfaceData&, char *);               //rbg}bv[h֐
	
//_CNgTEhn֐
bool DS_INIT(HWND);                                     //_CNgTEh֐  
void DS_END(void);                                      //_CNgTEhI֐
bool DS_LoadWave(LPDIRECTSOUNDBUFFER& DSBuffer, char *);//EGCut@C[h֐
void MIDI_Play(char*);                                  //~fBt@CĐ֐  
void MIDI_Stop(void);                                   //~fBt@C~֐  

//Q[C[`֐
void Main_Proc(HWND hwnd); 

//̑̕⏕֐                                                                 
bool  Error(char*);                                    //G[֐ 
char* DirectoryFound(void);                            //JgfBNg֐
void  Event_Proc(WPARAM, HWND);                        //L[Cxg֐
void  Key_Input(unsigned int, int *);                  //L[͎擾֐
int   my_rand(int, int);                               //쐬֐

/*********************************************************************************************/
/*                              ėpCũCN[h  @                             */
/*********************************************************************************************/
#include "d3d_tex.h"
#include "d3d_lib.h"
#include "d3d_Mat.h"

/*********************************************************************************************/
/*                        @@          C֐           @                              */
/*********************************************************************************************/
int PASCAL WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,
				   LPSTR lpCmdLine,int nCmdShow)
{
	WNDCLASS      wc;
	MSG           msg;
	HRESULT       ddret; 

	////////////////////////////// EChE ///////////////////////////////////
	wc.style         = CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS;
	wc.lpfnWndProc   = WindowProc;
	wc.cbClsExtra    = 0;
	wc.cbWndExtra    = 0;
	wc.hInstance     = hInstance;
	wc.hIcon         = LoadIcon(hInstance,"MAIN");
	wc.hCursor       = LoadCursor(NULL,IDC_ARROW);
	wc.hbrBackground = (HBRUSH)GetStockObject(BLACK_BRUSH);
	wc.lpszMenuName  = "DEFAULT";
	wc.lpszClassName = "DEFAULT";

	RegisterClass(&wc);
	hwnd = CreateWindowEx(0,"DEFAULT","DEFAULT",WS_POPUP|WS_SYSMENU,0,0,
						GetSystemMetrics(SM_CXSCREEN),
						GetSystemMetrics(SM_CYSCREEN),
						NULL,NULL,hInstance,NULL);
	//EChEɎsvOI
	if (!hwnd) return FALSE;
	_Instance = hInstance;

	//EChE쐬
	ShowWindow(hwnd,nCmdShow);
	UpdateWindow(hwnd);

	///////////////////////////// _CNgw //////////////////////////////////
	//_CNgh[
	if (DD_INIT(hwnd) == false) {
		MessageBox( hwnd, "_CNgh[̏Ɏs܂","", MB_OK);
		return (false);
	}
	//_CNgRc
	if (D3D_INIT(hwnd) == false) {
		MessageBox( hwnd, "_CNgRc̏Ɏs܂","", MB_OK);
		return (false);
	}
	//_CNgTEh
	if (DS_INIT(hwnd) == false) {
		MessageBox( hwnd, "_CNgTEh̏Ɏs܂","", MB_OK);
		return (false);
	}
				
	//t[^C̏
	Save_time = GetTickCount();
	
	//}EXJ[\It
	ShowCursor(FALSE);

	///////////////////////////// bZ[W[v //////////////////////////////////
	while (TRUE)
	{
		// bZ[Wꍇ
		if (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)) {
			if (msg.message == WM_QUIT) break;

			TranslateMessage(&msg);
			DispatchMessage(&msg);
		} else	{
			//t[^C̍XV
			FrameTime = (float)(GetTickCount() - Save_time) / 1000.0f;
			Save_time = GetTickCount();
			
			//ʂ̍XViœhׂj
			DD_BackInit();
			
			//又
			Main_Proc(hwnd);
			
			//\ʂƗʂ̐؂芷
			RECT rect;  
			rect.left   = 0;
			rect.top    = 0;
			rect.right  = SCREEN_WIDTH;
			rect.bottom = SCREEN_HEIGHT;
	
			ddret = DDFront->BltFast(0, 0, DDBack, &rect,	DDBLTFAST_WAIT);
			if (ddret == DDERR_SURFACELOST) DDFront->Restore();
		}
	}
	
	return TRUE;
}


/*********************************************************************************************/
/*                     @            bZ[W֐         @                           */
/*********************************************************************************************/
long FAR PASCAL WindowProc(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam)
{
	int i;  //ėpJE^   
	switch (msg)
	{
		//EChE쐬̏
		case WM_CREATE:
			//rbg}bvێpT[tFX̏
			for (i = 0; i <= BITMAP_NUM - 1; i ++) Bitmap[i].Surface = NULL;
			//TEhobt@̏
			for (i = 0; i <= SOUND_NUM - 1; i ++)  Wave[i] = NULL;
			break;
		//}EXW擾
		case WM_MOUSEMOVE:
			MouseX = LOWORD(lParam);
			MouseY = HIWORD(lParam);
			break;
		//lbhCxg
		case MM_MCINOTIFY:
			//lhcht@CIA[vs
			if (wParam==MCI_NOTIFY_SUCCESSFUL) {
				if (PlayFlg == true)	{
					mciSendString("status midi mode",MciBuffer,32,NULL);
					if (MciBuffer[0]=='s' && MciBuffer[1]=='t') {
						mciSendString("seek midi to start", NULL, 0, NULL);
						mciSendString("play midi notify", NULL, 0, hwnd);
					}
				}
			}
			break;
		// L[ꂽꍇ
		case WM_KEYDOWN:
			Event_Proc(wParam, hwnd);
			break;
		// EBhEꍇ
		case WM_CLOSE:
			ShowCursor(TRUE);   //}EXJ[\I
			D3D_END();          //_CNgRcJ
			DD_END(hwnd);       //_CNgh[J
			DS_END();           //_CNgTEhJ
			MIDI_Stop();        //lhchXgbv
			CloseWindow(hwnd);  //EChEN[Y
			DestroyWindow(hwnd);
			return 0L;
		// EBhEjꍇ
		case WM_DESTROY:
			PostQuitMessage(0); // I
			break;
	}
	
	return DefWindowProc(hwnd,msg,wParam,lParam);
}


//===========================================================================================//
//                     @           _CNgh[n֐      @                           //
//===========================================================================================//
/*************************************************************************/
/*                     _CNgh[֐                        */
/*************************************************************************/
bool DD_INIT(HWND hwnd)
{
	DDSURFACEDESC ddsd;
	DDSCAPS       ddscaps;
	HRESULT       ddret;    //_CNgh[n֐̖߂li[ϐ@
	
	LPDIRECTDRAW  OldDDObject = NULL;
    
	// DirectDrawhCo񋓂
    ddret = DirectDrawEnumerate(DDEnumCallback, &OldDDObject);

    // 񋓂ɂDirectDrawhCo肵ȂꍇC݃ANeBuȃhCog
    if (OldDDObject == NULL) {
		ddret = DirectDrawCreate(NULL, &OldDDObject, NULL);
		if (ddret != DD_OK) return FALSE;
	}

	//XN[[h̕ύX@
	ddret = OldDDObject->SetCooperativeLevel(hwnd, DDSCL_EXCLUSIVE|DDSCL_FULLSCREEN);
	if (ddret != DD_OK) return Error("tXN[ł܂");

	// VDirectDraw2IuWFNg擾
	OldDDObject->QueryInterface(IID_IDirectDraw2, (LPVOID *)&DDObject);
	RELEASE(OldDDObject);
	if (ddret != DD_OK) return FALSE;

	//𑜓xƃJ[rbg̐ݒ
	ddret = DDObject->SetDisplayMode(SCREEN_WIDTH, SCREEN_HEIGHT, 16, 0, 0);
	if (ddret != DD_OK) return Error("𑜓xύXł܂");
	
	//vC}BT[tF[X̐
	memset(&ddsd, 0, sizeof(DDSURFACEDESC));
	ddsd.dwSize         = sizeof(DDSURFACEDESC);
	ddsd.dwFlags        = DDSD_CAPS|DDSD_BACKBUFFERCOUNT;
	ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE|DDSCAPS_FLIP
						  |DDSCAPS_COMPLEX|DDSCAPS_3DDEVICE;
	ddsd.dwBackBufferCount = 1;

	//쐬_CNgh[IuWFNgɑ΂ăvC}BT[tF[X𐶐
	LPDIRECTDRAWSURFACE	OldDDFront;
	ddret = DDObject->CreateSurface(&ddsd, &OldDDFront, NULL);
	if (ddret != DD_OK) {
		RELEASE(OldDDFront);
		return Error("vC}BT[tF[Xł܂");
	}
	//VDirectDrawSurface3𐶐ÂIuWFNg͊J
	ddret = OldDDFront->QueryInterface(IID_IDirectDrawSurface3, (LPVOID *)&DDFront);
	RELEASE(OldDDFront);
	if(ddret != DD_OK) return FALSE;
	
	//obNobt@̐@
	ddscaps.dwCaps = DDSCAPS_BACKBUFFER;
	ddret = DDFront->GetAttachedSurface(&ddscaps, &DDBack);
	if (ddret!=DD_OK) return Error("obNobt@ł܂");

	return (true);
}

/*************************************************************************/
/*                    _CNgh[J֐                       */
/*************************************************************************/
void DD_END(HWND hwnd)
{
	int i;
	if (DDObject != NULL) {
		//ItXN[T[tFX̉
		for (i = 0; i <= BITMAP_NUM - 1; i ++) {
			if (Bitmap[i].Surface != NULL) Bitmap[i].Surface->Release();
		}
		//_CNgh[J
		if (DDFront != NULL)       DDFront->Release();
		// 𑜓x̕AƃtXN[̏I
		DDObject->RestoreDisplayMode();
		DDObject->SetCooperativeLevel(hwnd,DDSCL_NORMAL);
		DDObject->Release();
	}
}			

/*************************************************************************/
/*                        @tHg\֐@                           */
/*************************************************************************/
void DD_FontShow(char *str, int size, int X, int Y, int R, int G, int B, bool ITALIC = false)
{
	//tHgϐ
	static HFONT    NewFont,OldFont;
	static HDC      FontDC;
	static PLOGFONT FontInfo;
	
	if(DDBack->GetDC(&FontDC) == DD_OK){
		//tHgCtH
		FontInfo  = (PLOGFONT)GlobalAlloc(GPTR, sizeof(LOGFONT));
		//tHg^Cvݒ
		BOOL Bold = FALSE;
		lstrcpy(FontInfo->lfFaceName, "W");
		FontInfo->lfWeight     = (Bold == FALSE)*FW_NORMAL + (Bold == TRUE)*FW_BOLD;
		FontInfo->lfEscapement = 0;
		FontInfo->lfWidth      = 0;
		FontInfo->lfHeight     = size;
		FontInfo->lfItalic     = ITALIC;
		FontInfo->lfUnderline  = FALSE;
		FontInfo->lfCharSet    = SHIFTJIS_CHARSET;
		//foCXReLXg擾
		NewFont = CreateFontIndirect(FontInfo);
		OldFont = (HFONT)SelectObject(FontDC, NewFont);
	    //`揈
		SetBkMode(FontDC, TRANSPARENT);
		SetTextColor(FontDC, RGB(R, G, B));
		TextOut(FontDC, X, Y, str, strlen(str));
		//foCXReLXgJ
		SelectObject(FontDC, OldFont);
		DeleteObject(NewFont);
		DDBack->ReleaseDC(FontDC);
		//tHgCtHJ
		GlobalFree((LOCALHANDLE)FontInfo);
	}
}

/*************************************************************************/
/*                        @ C`֐ @                           */
/*************************************************************************/
void DD_DrawLine(int X1,int Y1,int X2,int Y2, int Size, int R, int G, int B)
{
	HDC hdc;
	HPEN NewPen;    //Vyۑϐ
	HPEN OldPen;    //ftHg̃yۑϐ

	DDBack->GetDC(&hdc);                          //foCXReLXg̎擾

	NewPen = CreatePen(PS_SOLID,Size,RGB(R,G,B)); //`py̍쐬
	OldPen = (HPEN)SelectObject(hdc, NewPen);     //y̑IƃftHg̃ỹZ[u

	//C`揈
	MoveToEx(hdc, X1, Y1, NULL);
	LineTo(hdc, X2, Y2);

	//IuWFNg̃[X
	SelectObject(hdc, OldPen);
	DeleteObject(NewPen);
	DDBack->ReleaseDC(hdc);
}

/*************************************************************************/
/*                        rbg}bv`֐                           */
/*************************************************************************/
void DD_DrawBitmap(int x, int y, SurfaceData& DDbitmap,int x1, int y1, int x2, int y2)
{
	HRESULT       ddret;    //_CNgh[n֐̖߂li[ϐ@
	RECT          rect;
	
	//NbsO
	  //`悪ʉE[͂ݏoĂ鎞̏
	if (x + (x2 - x1) > SCREEN_WIDTH)	x2 -= (x + (x2 - x1) - SCREEN_WIDTH);
	  //`悪ʉ[͂ݏoĂ鎞̏
	if (y + (y2 - y1) > SCREEN_HEIGHT)	y2 -= (y + (y2 - y1) - SCREEN_HEIGHT);
	  //`悪ʍ[͂ݏoĂ鎞̏
	if (x < 0)	{
		x1 -= x;
		x   = 0;
	}
	  //`悪ʏ[͂ݏoĂ鎞̏
	if (y < 0) {
		y1 -= y;
		y   = 0;
	}
	  //sȒlƈȉ̕`揈sȂ
	if (x2 < x1 || y2 < y1) return;
	
	rect.left   = x1;
	rect.top    = y1;
	rect.right  = x2;
	rect.bottom = y2;
		
	//ahsl`o̕`揈
	ddret = DDBack->BltFast(x, y, DDbitmap.Surface, &rect, DDBLTFAST_SRCCOLORKEY|DDBLTFAST_WAIT);
	
	//T[tFXXg̏
	if (ddret == DDERR_SURFACELOST) {
		DDFront->Restore();
		DDbitmap.Surface->Restore();
		
		DD_LoadBitmap(DDbitmap, DDbitmap.SaveData);
	}

	return; 
}

/*************************************************************************/
/*                    rbg}bv[h֐                         */
/*************************************************************************/
bool DD_LoadBitmap(SurfaceData& DDSurface, char *BitmapName)
{
	HRESULT       ddret;

	//rbg}bv[h
	HBITMAP             hBitmap;  //rbg}bvnh
	hBitmap = (HBITMAP)LoadImage(NULL, BitmapName, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE|LR_CREATEDIBSECTION);

    if (hBitmap == NULL) return false;

	//̃rbg}bvpDirectDrawSurface쐬
    DDSURFACEDESC        ddsd;
    LPDIRECTDRAWSURFACE  oldpdds;
	LPDIRECTDRAWSURFACE3 pdds;
	BITMAP               BitMap;

	ZeroMemory(&ddsd, sizeof(ddsd));
    ddsd.dwSize = sizeof(ddsd);
    ddsd.dwFlags = DDSD_CAPS | DDSD_HEIGHT |DDSD_WIDTH;
    ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN;
	// rbg}bṽTCY擾
    GetObject(hBitmap, sizeof(BitMap), &BitMap);
    
    ddsd.dwWidth = BitMap.bmWidth > SCREEN_WIDTH ? SCREEN_WIDTH : BitMap.bmWidth;//CT[tF[X艡͑傫Ȃ̂
	ddsd.dwHeight = abs(BitMap.bmHeight);
	
	//T[tFX쐬
    if (DDObject->CreateSurface(&ddsd, &oldpdds, NULL) != DD_OK) {
		RELEASE(oldpdds);
		return false;
	}
		
	//VDirectDrawSurface3𐶐ÂIuWFNg͊J
	ddret = oldpdds->QueryInterface(IID_IDirectDrawSurface3, (LPVOID *)&pdds);
	RELEASE(oldpdds);
	if(ddret != DD_OK) return FALSE;

	// rbg}bvT[tF[XɃRs[
	HDC hdcBitmap;
	HDC	hdc;
	HBITMAP hbmOld;

	hdcBitmap = CreateCompatibleDC(NULL);
    hbmOld = (HBITMAP)SelectObject(hdcBitmap, hBitmap);

	pdds->GetDC(&hdc);
	
	BitBlt(hdc, 0, 0, ddsd.dwWidth, ddsd.dwHeight, hdcBitmap, 0, 0, SRCCOPY);
	
	pdds->ReleaseDC(hdc);

	SelectObject(hdcBitmap, hbmOld);
	DeleteDC(hdcBitmap);
	
	DDSurface.Surface  = pdds;
	DDSurface.SaveData = BitmapName;
	
	//J[L[̎w
	DDCOLORKEY          ddck;
    ddck.dwColorSpaceLowValue  = 0;
    ddck.dwColorSpaceHighValue = 0;
    DDSurface.Surface->SetColorKey(DDCKEY_SRCBLT, &ddck);

	//XvCgTCY̎擾
	ZeroMemory(&ddsd,sizeof(DDSURFACEDESC));
	ddsd.dwSize = sizeof(DDSURFACEDESC);
	DDSurface.Surface->GetSurfaceDesc(&ddsd);
	DDSurface.dwPitch  = (DWORD)ddsd.lPitch;
	DDSurface.dwWidth  = (DWORD)ddsd.dwWidth;
	DDSurface.dwHeight = (DWORD)ddsd.dwHeight;
	
	return true;
}

/*************************************************************************/
/*                      XN[̏֐                           */
/*************************************************************************/
void DD_BackInit(void)
{
	// ʂŏ
	static DDBLTFX ddbltfx;
	static RECT rect;
	rect.left           = 0;
	rect.top            = 0;
	rect.right          = SCREEN_WIDTH;
	rect.bottom         = SCREEN_HEIGHT;
	ddbltfx.dwSize      = sizeof(ddbltfx);
	ddbltfx.dwFillColor = 0;
	DDBack->Blt(&rect, NULL, NULL, DDBLT_COLORFILL | DDBLT_WAIT, &ddbltfx);
}

//===========================================================================================//
//                     @         _CNgTEhn֐      @                           //
//===========================================================================================//
/*************************************************************************/
/*                   _CNgTEh֐                        */
/*************************************************************************/
bool DS_INIT(HWND hwnd) {
	
	//DirectSound̐
	if(DirectSoundCreate(NULL, &DSObject, NULL) != DS_OK)          
			Error("DirectSoundł܂DirectSound̎gps\ł");
	
	//DirectSound̋x̐ݒ
	if(DSObject->SetCooperativeLevel(hwnd, DSSCL_NORMAL) != DS_OK) 
			Error("DirectSound̋Ɏs܂");
		
	return true;
}

/*************************************************************************/
/*                   _CNgTEhJ֐                      */
/*************************************************************************/
void DS_END(void)
{
	int i;     //ėpJE^
	//TEhobt@̊J
	for (i = 0; i <= SOUND_NUM - 1; i ++) {
		if (Wave[i] != NULL) Wave[i]->Release();
	}
	//_CNgTEhIuWFNg̊J
	if(DSObject != NULL) DSObject->Release();
}

/*************************************************************************/
/*                  @EGCut@CĐ֐                       */
/*************************************************************************/
void DS_Play(LPDIRECTSOUNDBUFFER DSBuffer)
{
	DSBuffer->Stop();
	DSBuffer->SetCurrentPosition (0);	
	DSBuffer->Play(0, 0, 0);
}


/*************************************************************************/
/*                 @EGCut@Cǂݍݏ                      */
/*************************************************************************/
bool DS_LoadWave(LPDIRECTSOUNDBUFFER& pDSBuffer, char *szWaveFile)
{
	HMMIO	hmfr;
	MMCKINFO parent,child;
	WAVEFORMATEX wfmtx;

	// WAVEt@C}`fBAI/O֐ŊJ܂
	hmfr = mmioOpen(szWaveFile, NULL, MMIO_READ | MMIO_ALLOCBUF);
	if(hmfr == NULL) {
		MessageBox(NULL, "t@CI[vɎs܂", NULL, MB_OK);
		return FALSE;
	}

	parent.ckid         = (FOURCC)0;
	parent.cksize       = 0;
	parent.fccType      = (FOURCC)0;
	parent.dwDataOffset = 0;
	parent.dwFlags      = 0;
	child               = parent;

	parent.fccType = mmioFOURCC('W','A','V','E');
	if(mmioDescend(hmfr, &parent, NULL, MMIO_FINDRIFF)) {
		mmioClose(hmfr,0);
		Error("EGCut@C܂");
		return FALSE;
	}

	child.ckid = mmioFOURCC('f','m','t',' ');
	if(mmioDescend(hmfr, &child, &parent, 0)) {
		mmioClose(hmfr,0);
		Error("EGCut@C܂");
		return FALSE;
	}

	// WAṼtH[}bgǂݍ݂܂
	if(mmioRead(hmfr, (char *)&wfmtx, sizeof(wfmtx)) != sizeof(wfmtx)) {
		mmioClose(hmfr, 0);
		Error("EGCutH[}bgǂݍ߂܂");
		return FALSE;
	}

	// ̃t@CWAVEt@Cł邱ƂmF܂
	if(wfmtx.wFormatTag != WAVE_FORMAT_PCM) {
		mmioClose(hmfr,0);
		Error("sȃEGCutH[}bgł");
		return FALSE;
	}
		
	if(mmioAscend(hmfr, &child, 0)) {
		mmioClose(hmfr,0);
		Error("EGCut@CɃANZXł܂");
		return FALSE;
	}
		
	// `N\̂ɓǂݍ݂܂
	child.ckid = mmioFOURCC('d','a','t','a');
	if(mmioDescend(hmfr,&child, &parent, MMIO_FINDCHUNK)) {
		mmioClose(hmfr,0);
		Error("EGCut@CɃf[^܂");
		return FALSE;
	}

	// 蓖āAf[^ǂݍ݂܂
	BYTE *pBuffer= new BYTE[child.cksize];
	if((DWORD)mmioRead(hmfr, (char *)pBuffer, child.cksize) != child.cksize) {
		mmioClose(hmfr,0);
		Error("EGCuf[^ǂݍ݂Ɏs܂");
		return FALSE;
	}

	// WAVEt@C܂
	mmioClose(hmfr,0);


	// DirectSoundobt@쐬܂
	DSBUFFERDESC dsbdesc;
	PCMWAVEFORMAT pcmwf;
	
	memset(&pcmwf, 0, sizeof(PCMWAVEFORMAT));
	pcmwf.wf.wFormatTag      = WAVE_FORMAT_PCM;
	pcmwf.wf.nChannels	     = wfmtx.nChannels;
	pcmwf.wf.nSamplesPerSec	 = wfmtx.nSamplesPerSec;
	pcmwf.wf.nBlockAlign     = wfmtx.nBlockAlign;
	pcmwf.wf.nAvgBytesPerSec = wfmtx.nAvgBytesPerSec;
	pcmwf.wBitsPerSample     = wfmtx.wBitsPerSample;
	

	memset(&dsbdesc, 0, sizeof(DSBUFFERDESC));
	dsbdesc.dwSize        = sizeof(DSBUFFERDESC);
	dsbdesc.dwFlags       = DSBCAPS_CTRLFREQUENCY | DSBCAPS_CTRLVOLUME
								| DSBCAPS_CTRLPAN;
	
	dsbdesc.dwBufferBytes = child.cksize;			
	dsbdesc.lpwfxFormat   = (LPWAVEFORMATEX)&pcmwf;

	if(DSObject->CreateSoundBuffer(&dsbdesc, &pDSBuffer, NULL) != DS_OK) {
		Error("TEhobt@̐Ɏs܂");
		delete [] pBuffer;
	}


	// WAVt@C̃f[^obt@ɓ]܂
	LPVOID written1, written2;
	DWORD length1,length2;
	if(pDSBuffer->Lock(0, child.cksize, &written1, &length1, &written2, &length2, 0) == DSERR_BUFFERLOST) {
		pDSBuffer->Restore();
		pDSBuffer->Lock(0, child.cksize, &written1, &length1, &written2, &length2, 0);
	}

	CopyMemory(written1, pBuffer, length1);

	if(written2 != NULL) CopyMemory(written2, pBuffer+length1, length2);

	pDSBuffer->Unlock(written1, length1, written2, length2);

	// Ɨp̃obt@܂
	delete [] pBuffer;

	return TRUE;
}

/*************************************************************************/
/*                   @@@lhchĐ֐@                        */
/*************************************************************************/
void MIDI_Play(char* FileName)
{
	char Buffer[256];

	sprintf(Buffer, "open \"%s%s\" type sequencer alias midi", DirectoryFound(), FileName);

	if (PlayFlg == true) MIDI_Stop(); 

	mciSendString(Buffer, NULL, 0, NULL);
	mciSendString("seek midi to start",NULL, 0, NULL);
	mciSendString("play midi notify",  NULL, 0, hwnd);

	PlayFlg = true;
}

/*************************************************************************/
/*                   @@@lhch~֐@@                      */
/*************************************************************************/
void MIDI_Stop(void)
{
	if (PlayFlg == true) {
		mciSendString("stop midi",  NULL, 0, NULL);
		mciSendString("close midi", NULL, 0, NULL);

		PlayFlg = false;
	}
}

//===========================================================================================//
//                     @         @@@VXen֐@@      @                           //
//===========================================================================================//
/*************************************************************************/
/*                        @G[֐@@                           */
/*************************************************************************/
bool Error(char* Message)
{
	if (DDObject != NULL)  DDObject->FlipToGDISurface();

	MessageBox(hwnd, Message, "G[", MB_OK);

	return (false);
}

/*************************************************************************/
/*                          쐬֐                                 */
/*************************************************************************/
//@low@@high@܂ł̒l̗쐬
int my_rand(int low, int high)
{
	return ((int)((high - low + 1) * (rand() / 32767.1) + low));
}

/*************************************************************************/
/*                   JgfBNg֐                        */
/*************************************************************************/
char* DirectoryFound(void)
{
	static int i;
	static char Buffer[256];
	
	// JgfBNgB̎擾
	GetModuleFileName(_Instance, Buffer, 256);

	for (i = strlen(Buffer); Buffer[i] != '\\'; i--) Buffer[i] = NULL;
	
	return Buffer;
}

/*************************************************************************/
/*                        @L[͏֐@                           */
/*************************************************************************/
void Key_Input(unsigned int Code,int* Flag)
{
	if ((GetKeyState(Code)&0x80) == 0x80) //codeΉL[ꂽ
	{
		if (*Flag == FREE_KEY)                     
			*Flag = PUSH_KEY;
		else                                     
			*Flag = HOLD_KEY;
	}
	else                                  //L[ĂȂ
	{
		if (*Flag == PUSH_KEY || *Flag == HOLD_KEY) 
			*Flag = PULL_KEY;
		else
			*Flag = FREE_KEY;                      
	}
}



